#ifndef SIMPLE_GUI_2D_SLIDER_H
#define SIMPLE_GUI_2D_SLIDER_H

#include "simpleGuiBaseObject.h"
#include "simpleGuiColor.h"
#include "simpleColor.h"
#include "simpleGuiValue.h"

class simpleGui2DSlider : public simpleGuiBaseObject{

    public:

        simpleGui2DSlider(){
            knobSize = 6.0;
        }

        //------------------------------------------------
        void setup(string sliderName, float defaultVal1, float min1, float max1, float defaultVal2, float min2, float max2){
            value.addValue(defaultVal1, min1, max1);
            value.addValue(defaultVal2, min2, max2);
            name = sliderName;
        }

        //-----------------------------------------------.
        void update(float x, float y){
            if( state == SG_STATE_SELECTED){
                float pct1 = ( x - ( hitArea.x ) ) / hitArea.width;
                value.setValueAsPct( pct1, 0);
                float pct2 = ( y - ( hitArea.y ) ) / hitArea.height;
                value.setValueAsPct( pct2, 1);
            }
        }

        //-----------------------------------------------
        void setKnobSize(float _knobSize){
            knobSize = _knobSize;
        }

        //-----------------------------------------------.
        void render(){
            glPushMatrix();
            //glTranslatef(boundingBox.x, boundingBox.y, 0);

                //draw the background
                ofFill();
                glColor4fv(bgColor.getColorF());
                ofRect(hitArea.x, hitArea.y, hitArea.width, hitArea.height);

                //draw the foreground

                float boxWidth  = knobSize;
                float boxHeight = knobSize;

                float bx = hitArea.x + (boxWidth * 0.5) + ( value.getPct(0) * (hitArea.width - (boxWidth)) );
                float by = hitArea.y + (boxHeight * 0.5) + ( value.getPct(1) * (hitArea.height - (boxHeight)) );

                glColor4fv(fgColor.getColorF());
                ofSetRectMode(OF_RECTMODE_CENTER);
                ofRect(bx, by, boxWidth, boxHeight);
                ofSetRectMode(OF_RECTMODE_CORNER);

                //draw the outline
                ofNoFill();
                glColor4fv(outlineColor.getColorF());
                ofRect(hitArea.x, hitArea.y, hitArea.width, hitArea.height);

                simpleGuiBaseObject::renderText();

            glPopMatrix();
        }

        float knobSize;

};

#endif
