#ifndef SIMPLE_GUI_SLIDER_H
#define SIMPLE_GUI_SLIDER_H

#include "simpleGuiBaseObject.h"
#include "simpleGuiColor.h"
#include "simpleColor.h"
#include "simpleGuiValue.h"

class simpleGuiSlider : public simpleGuiBaseObject{

    public:

        //------------------------------------------------
        void setup(string sliderName, float defaultVal, float min, float max){
            value.addValue(defaultVal, min, max);
            name = sliderName;
        }

        //-----------------------------------------------.
        void update(float x, float y){
            if( state == SG_STATE_SELECTED){
                float pct = ( x - ( hitArea.x ) ) / hitArea.width;
                value.setValueAsPct( pct );
            }
        }

        //-----------------------------------------------.
        void render(){
            glPushMatrix();

                //draw the background
                ofFill();
                glColor4fv(bgColor.getColorF());
                ofRect(hitArea.x, hitArea.y, hitArea.width, hitArea.height);

                //draw the foreground
                glColor4fv(fgColor.getColorF());
                ofRect(hitArea.x, hitArea.y, hitArea.width * value.getPct(), hitArea.height);

                //draw the outline
                ofNoFill();
                glColor4fv(outlineColor.getColorF());
                ofRect(hitArea.x, hitArea.y, hitArea.width, hitArea.height);

                simpleGuiBaseObject::renderText();

            glPopMatrix();
        }


};

#endif
